(defun c:TSP-FN (/ *error* tttt wcs initvalueslst ucsf ti permutate trimlst ncdrlst foo f1 ins-lst get-closest-i get-closedpolygon-length car-sort chkinters chkinters-p collinear-p MR:ConvexHull-ptsonHull _vl-sort mindist-eea-MR greedy grid unique generic foo1 xxx1 foo2 xxx2 foo3 xxx3 foo4 xxx4 foo5 xxx5 fff mchull makelw ss i pl pl1 pl2 pl3 pl4 pl5 pl6 pl7 pl8 pl9 flag flagg n)

  (defun *error* (m)
    (if wcs
      (if ucsf
        (while
          (not
            (and
              (equal (getvar (quote ucsxdir)) (car ucsf) 1e-6)
              (equal (getvar (quote ucsydir)) (cadr ucsf) 1e-6)
              (equal (trans (list 0.0 0.0 1.0) 1 0 t) (caddr ucsf) 1e-6)
            )
          )
          (exe (list "_.UCS" "_P"))
        )
      )
    )
    (while (= 8 (logand 8 (getvar (quote undoctl))))
      (if (not (exe (list "_.UNDO" "_E")))
        (if doc
          (vla-endundomark doc)
        )
      )
    )
    (if initvalueslst
      (mapcar (function apply_cadr->car) initvalueslst)
    )
    (foreach fun (list (quote tttt) (quote vl-load) (quote exe) (quote cmdfun) (quote cmderr) (quote catch_cont) (quote apply_cadr->car) (quote ftoa))
      (setq fun nil)
    )
    (if doc
      (vla-regen doc acactiveviewport)
    )
    (if m
      (prompt m)
    )
    (princ)
  )

  (defun tttt (wcs / sysvarpreset sysvarlst sysvarvals)  ;;; wcs (T/nil) ;;; cad, doc, alo, spc - global variables (Visual Lisp main VLA-OBJECT pointers) ;;; vl-load exe cmdfun cmderr catch_cont apply_cadr->car ftoa - library sub functions common for standard template initialization ;;;

    (defun vl-load nil
      (or cad
        (if vlax-get-acad-object
          (setq cad (vlax-get-acad-object))
          (progn
            (vl-load-com)
            (setq cad (vlax-get-acad-object))
          )
        )
      )
      (or doc (setq doc (vla-get-activedocument cad)))
      (or alo (setq alo (vla-get-activelayout doc)))
      (or spc (setq spc (vla-get-block alo)))
    )

    ;;; sometimes not needed to use/initialize AxiveX Visual Lisp extensions - (comment/uncomment) following line ;;;
    (or (and cad doc alo spc) (vl-load))

    (defun exe (tokenslist)
      ((lambda (tokenslist / ctch)
         (if (vl-catch-all-error-p (setq ctch (cmdfun tokenslist t)))
           (progn
             (cmderr tokenslist)
             (catch_cont ctch)
           )
           (progn
             (while (< 0 (getvar (quote cmdactive)))
               (vl-cmdf "")
             )
             t
           )
         )
       )
         tokenslist
      )
    )

    (defun cmdfun (tokenslist flag / ctch)  ;;; tokenslist - command parameters list of strings ;;; flag - if "t" specified, upon successful execution returns t, otherwise if "nil" specified, return is always nil no matter what outcome of function execution is - it should be successful anyway if specified tokenslist was hardcoded correctly... ;;;
      (if command-s
        (if flag
          (if (not (vl-catch-all-error-p (setq ctch (vl-catch-all-apply (function command-s) tokenslist))))
            flag
            ctch
          )
          (if (vl-catch-all-error-p (setq ctch (vl-catch-all-apply (function command-s) tokenslist)))
            ctch
          )
        )
        (if flag
          (if (not (vl-catch-all-error-p (setq ctch (vl-catch-all-apply (function vl-cmdf) tokenslist))))
            flag
            ctch
          )
          (if (vl-catch-all-error-p (setq ctch (vl-catch-all-apply (function command) tokenslist)))
            ctch
          )
        )
      )
    )

    (defun cmderr (tokenslist)  ;;; tokenslist - list of tokens representing command syntax at which used (cmdfun) failed with successful execution ;;;
      (prompt (strcat "\ncommand execution failure... error at used command tokenslist : " (vl-prin1-to-string tokenslist)))
    )

    (defun catch_cont (ctch / gr)
      (prompt "\nleft mouse click to continue or enter to generate catch error - ESC to break...")
      (while
        (and
          (vl-catch-all-error-p (or ctch (setq ctch (vl-catch-all-apply (function /) (list 1 0)))))
          (setq gr (grread))
          (/= (car gr) 3)
          (not (equal gr (list 2 13)))
        )
      )
      (if (vl-catch-all-error-p ctch)
        ctch
      )
    )

    (defun apply_cadr->car (sysvarvaluepair / ctch)
      (setq ctch (vl-catch-all-apply (function setvar) sysvarvaluepair))
      (if (vl-catch-all-error-p ctch)
        (progn
          (prompt (strcat "\ncatched error on setting system variable : " (vl-prin1-to-string (vl-symbol-name (car sysvarvaluepair))) " with value : " (vl-prin1-to-string (cadr sysvarvaluepair))))
          (catch_cont ctch)
        )
      )
    )

    (defun ftoa (n / m a s b)
      (if (numberp n)
        (progn
          (setq m (fix ((if (< n 0) - +) n 1e-8)))
          (setq a (abs (- n m)))
          (setq m (itoa m))
          (setq s "")
          (while (and (not (equal a 0.0 1e-6)) (setq b (fix (* a 10.0))))
            (setq s (strcat s (itoa b)))
            (setq a (- (* a 10.0) b))
          )
          (if (= (type n) (quote int))
            m
            (if (= s "")
              m
              (if (and (= m "0") (< n 0))
                (strcat "-" m "." s)
                (strcat m "." s)
              )
            )
          )
        )
      )
    )

    (setq sysvarpreset
          (list
            (list (quote cmdecho) 0)
            (list (quote 3dosmode) 0)
            (list (quote osmode) 0)
            (list (quote unitmode) 0)
            (list (quote cmddia) 0)
            (list (quote ucsvp) 0)
            (list (quote ucsortho) 0)
            (list (quote projmode) 0)
            (list (quote orbitautotarget) 0)
            (list (quote insunits) 0)
            (list (quote hpseparate) 0)
            (list (quote hpgaptol) 0)
            (list (quote halogap) 0)
            (list (quote edgemode) 0)
            (list (quote pickdrag) 0)
            (list (quote qtextmode) 0)
            (list (quote dragsnap) 0)
            (list (quote angdir) 0)
            (list (quote aunits) 0)
            (list (quote limcheck) 0)
            (list (quote gridmode) 0)
            (list (quote nomutt) 0)
            (list (quote apbox) 0)
            (list (quote attdia) 0)
            (list (quote blipmode) 0)
            (list (quote copymode) 0)
            (list (quote circlerad) 0.0)
            (list (quote filletrad) 0.0)
            (list (quote filedia) 1)
            (list (quote autosnap) 1)
            (list (quote objectisolationmode) 1)
            (list (quote highlight) 1)
            (list (quote lispinit) 1)
            (list (quote layerpmode) 1)
            (list (quote fillmode) 1)
            (list (quote dragmodeinterrupt) 1)
            (list (quote dispsilh) 1)
            (list (quote fielddisplay) 1)
            (list (quote deletetool) 1)
            (list (quote delobj) 1)
            (list (quote dblclkedit) 1)
            (list (quote attreq) 1)
            (list (quote explmode) 1)
            (list (quote frameselection) 1)
            (list (quote ltgapselection) 1)
            (list (quote pickfirst) 1)
            (list (quote plinegen) 1)
            (list (quote plinetype) 1)
            (list (quote peditaccept) 1)
            (list (quote solidcheck) 1)
            (list (quote visretain) 1)
            (list (quote regenmode) 1)
            (list (quote celtscale) 1.0)
            (list (quote ltscale) 1.0)
            (list (quote osnapcoord) 2)
            (list (quote grips) 2)
            (list (quote dragmode) 2)
            (list (quote lunits) 2)
            (list (quote pickstyle) 3)
            (list (quote navvcubedisplay) 3)
            (list (quote pickauto) 3)
            (list (quote draworderctl) 3)
            (list (quote expert) 5)
            (list (quote auprec) 6)
            (list (quote luprec) 6)
            (list (quote pickbox) 6)
            (list (quote aperture) 6)
            (list (quote osoptions) 7)
            (list (quote dimzin) 8)
            (list (quote pdmode) 35)
            (list (quote pdsize) -1.5)
            (list (quote celweight) -1)
            (list (quote cecolor) "BYLAYER")
            (list (quote celtype) "ByLayer")
            (list (quote clayer) "0")
          )
    )
    (setq sysvarlst (mapcar (function car) sysvarpreset))
    (setq sysvarvals (mapcar (function cadr) sysvarpreset))
    (setq sysvarvals
          (vl-remove nil
                     (mapcar
                       (function (lambda (x)
                                         (if (getvar x) (nth (vl-position x sysvarlst) sysvarvals))
                                 )
                       )
                             sysvarlst
                     )
          )
    )
    (setq sysvarlst
          (vl-remove-if-not
            (function (lambda (x)
                              (getvar x)
                      )
            )
                            sysvarlst
          )
    )
    (setq initvalueslst
          (apply (function mapcar)
                 (cons (function list)
                       (list
                         sysvarlst
                         (mapcar (function getvar) sysvarlst)
                       )
                 )
          )
    )
    (apply (function mapcar)
           (cons (function setvar)
                 (list
                   sysvarlst
                   sysvarvals
                 )
           )
    )
    (while (= 8 (logand 8 (getvar (quote undoctl))))
      (if (not (exe (list "_.UNDO" "_E")))
        (if doc
          (vla-endundomark doc)
        )
      )
    )
    (if (not (exe (list "_.UNDO" "_M")))
      (if doc
        (vla-startundomark doc)
      )
    )
    (if wcs
      (if (= 0 (getvar (quote worlducs)))
        (progn
          (setq ucsf
                (list
                  (getvar (quote ucsxdir))
                  (getvar (quote ucsydir))
                  (trans (list 0.0 0.0 1.0) 1 0 t)
                )
          )
          (exe (list "_.UCS" "_W"))
        )
      )
    )
    wcs
  )

  ;; Permutations, Marko Ribar, d.i.a. (permutate '(0 1 2)) ; (permutate '(0 1 1))
  (defun permutate (l / al ll)
    (cond
      ((null l)
        nil
      )
      ((= (length l) 1)
          (list l)
      )
      ((> (length l) 1)
          (apply (function append) (mapcar (function (lambda (x) (setq al (cons x al) ll (if (null ll) (cdr l) (cdr ll))) (mapcar (function (lambda (y) (cons x y))) (permutate (append (reverse (cdr al)) ll))))) l))
      )
    )
  )

  (defun trimlst (l n / ll)
    (repeat n
      (setq ll (cons (car l) ll))
      (setq l (cdr l))
    )
    (reverse ll)
  )

  (defun ncdrlst (lst n)
    (repeat n
      (setq lst (cdr lst))
    )
    lst
  )

  (defun foo (l n / l1 l2 ll b bb d d1 f ff fff per loop k)
    (gc)
    (setq loop t)
    (while loop
      (setq b (trimlst l n))
      (setq d (get-closedpolygon-length l))
      (setq ll l)
      (setq k -1)
      (while (and loop (setq bb (nth (setq k (1+ k)) (if (not per) (setq per (permutate b)) per))))
        (setq l1 ll)
        (setq l1 (ncdrlst l1 n))
        (setq l2 (append bb l1))
        (foreach x bb
          (setq l1 (f1 x l1))
        )
        (if (and (> d (setq d1 (get-closedpolygon-length l1))) (not (equal d d1 1e-6)))
          (setq d d1
                l l1
                f t
          )
          (if (<= d d1)
            (setq f nil)
          )
        )
        (if (and (> d (setq d1 (get-closedpolygon-length l2))) (not (equal d d1 1e-6)))
          (setq d d1
                l l2
                ff t
          )
          (if (<= d d1)
            (setq ff nil)
          )
        )
        (if (or f ff)
          (setq fff (cons t fff))
          (setq fff (cons nil fff))
        )
        (if (>= (length (vl-remove t (trimlst fff (length l)))) (length l))
          (setq loop nil)
        )
      )
      (setq per nil)
      (setq l (append (cdr l) (list (car l))))
    )
    l
  )

  (defun f1 (a l)
    (ins-lst a (get-closest-i l a) l)
  )

  (defun ins-lst (new i lst)
    (append (reverse (member (nth i lst) (reverse lst))) (list new) (cdr (member (nth i lst) lst)))
  )

  (defun get-closest-i (lst p / l)
    (vl-position
      (car-sort
        (setq l
              (mapcar
                (function (lambda (p1 p2 / d d1 d2)
                  (setq d (distance p1 p2)
                        d1 (distance p p1)
                        d2 (distance p p2)
                  )
                  (- (+ d1 d2) d)
                ))
                (cons (last lst) lst)
                lst
              )
        )
        (function <)
      )
      l
    )
  )

  (defun get-closedpolygon-length (l)
    (apply (function +) (mapcar (function distance) (cons (last l) l) l))
  )

  (defun car-sort (lst cmp / rtn)
    (setq rtn (car lst))
    (foreach itm (cdr lst)
      (if (apply cmp (list itm rtn))
        (setq rtn itm)
      )
    )
    rtn
  )

  (defun chkinters (pl / unit v^v processlil _inters done r lill ilil iip lil)

    (defun unit (v / d)
      (if (not (equal (setq d (distance (list 0.0 0.0 0.0) v)) 0.0 1e-8))
        (mapcar
          (function (lambda (x)
            (/ x d)
          ))
          v
        )
        (progn
          (prompt "\nInvalid vector specification - strength near 0.0... Quitting...")
          (exit)
        )
      )
    )

    (defun v^v (u v)
      (list
        (- (* (cadr u) (caddr v)) (* (caddr u) (cadr v)))
        (- (* (caddr u) (car v)) (* (car u) (caddr v)))
        (- (* (car u) (cadr v)) (* (cadr u) (car v)))
      )
    )

    (defun processlil (ilil lil / pre mid suf ret)
      (setq pre (reverse (cdr (member (car ilil) (reverse lil)))))
      (setq mid (cdr (member (car ilil) lil)))
      (setq mid (cdr (member (cadr ilil) (reverse mid))))
      (setq mid (mapcar (function reverse) mid))
      (setq suf (cdr (member (cadr ilil) lil)))
      (setq ret (append pre (list (list (car (car ilil)) (car (cadr ilil)))) mid (list (list (cadr (car ilil)) (cadr (cadr ilil)))) suf))
      ret
    )

    (defun _inters (p1 p2 p3 p4 / v oo ip)
      (if (and bp rad)
        (setq oo bp)
        (setq oo o)
      )
      (setq v (v^v (v^v (mapcar (function -) p1 oo) (mapcar (function -) p2 oo)) (v^v (mapcar (function -) p3 oo) (mapcar (function -) p4 oo))))
      (if (and (equal v (list 0.0 0.0 0.0) 1e-6) (setq ip (inters p1 p2 p3 p4 nil)))
        (setq v (unit (mapcar (function -) oo ip)))
        (if (not (equal v (list 0.0 0.0 0.0) 1e-6))
          (setq v (unit v))
        )
      )
      (and
        ip
        p1
        p2
        p3
        p4
        oo
        v
        (setq ip (inters p1 p2 oo (mapcar (function +) oo (mapcar (function *) v (list 1e+6 1e+6 1e+6))) nil))
        (equal (distance p1 p2) (+ (distance p1 ip) (distance ip p2)) 1e-6)
        (setq ip (inters p3 p4 oo (mapcar (function +) oo (mapcar (function *) v (list 1e+6 1e+6 1e+6))) nil))
        (equal (distance p3 p4) (+ (distance p3 ip) (distance ip p4)) 1e-6)
      )
    )

    (setq lil (mapcar (function list) pl (append (cdr pl) (list (car pl)))))
    (while (not done)
      (setq ilil (vl-some (function (lambda (a) (vl-some (function (lambda (b / ip)
                                                           (progn
                                                             (if (vl-catch-all-error-p (setq iip (vl-catch-all-apply (function _inters) (list (car a) (cadr a) (car b) (cadr b))))) (setq iip (inters (car a) (cadr a) (car b) (cadr b))) (setq iip nil)) (if (and (not (equal (cadr a) (car b) 1e-6)) (not (equal (car a) (cadr b) 1e-6)) (not (or (and (collinear-p (car a) (car b) (cadr a)) (collinear-p (car a) (cadr b) (cadr a))) (and (collinear-p (car b) (car a) (cadr b)) (collinear-p (car b) (cadr a) (cadr b))))) (not (or (and (collinear-p (car a) (car b) (cadr a)) (collinear-p (car b) (cadr a) (cadr b))) (and (collinear-p (car b) (car a) (cadr b)) (collinear-p (car a) (cadr b) (cadr a))))))
                                                               (cond
                                                                 ((collinear-p (car a) (car b) (cadr a)) (setq ip (car b))) ((collinear-p (car a) (cadr b) (cadr a)) (setq ip (cadr b))) ((collinear-p (car b) (car a) (cadr b)) (setq ip (car a))) ((collinear-p (car b) (cadr a) (cadr b)) (setq ip (cadr a)))
                                                               )
                                                               (setq iip nil)
                                                             )
                                                             (cond
                                                               (iip (list a b iip)) (ip (list a b ip))
                                                             )
                                                           )
                                                         )
                                                )
                                            (vl-remove a lil)
                                            )
                                    )
                          )
                 lil
                 )
      )
      (cond
        ((and ilil (equal iip (caddr ilil) 1e-6))
              (setq lil (processlil ilil lil))
        )
        ((and ilil (equal (caar ilil) (caddr ilil) 1e-6))
          (cond
            ((and (not (equal (caar ilil) (caadr ilil) 1e-6)) (not (equal (caar ilil) (cadadr ilil) 1e-6)))
                  (setq lil (processlil ilil lil))
            )
            ((equal (caar ilil) (caadr ilil) 1e-6)
                    (setq lil (processlil ilil lil))
            )
            ((equal (caar ilil) (cadadr ilil) 1e-6)
                    (setq ilil (subst (assoc (cadadr ilil) lil) (cadr ilil) ilil))
                    (setq lil (processlil ilil lil))
            )
          )
        )
        ((and ilil (equal (cadar ilil) (caddr ilil) 1e-6))
          (cond
            ((and (not (equal (cadar ilil) (caadr ilil) 1e-6)) (not (equal (cadar ilil) (cadadr ilil) 1e-6)))
                  (setq ilil (subst (assoc (cadar ilil) lil) (car ilil) ilil))
                  (setq lil (processlil ilil lil))
            )
            ((equal (cadar ilil) (caadr ilil) 1e-6)
                    (setq ilil (subst (assoc (cadar ilil) lil) (car ilil) ilil))
                    (setq lil (processlil ilil lil))
            )
            ((equal (cadar ilil) (cadadr ilil) 1e-6)
                    (setq ilil (subst (assoc (cadar ilil) lil) (car ilil) ilil))
                    (setq ilil (subst (assoc (cadadr ilil) lil) (cadr ilil) ilil))
                    (setq lil (processlil ilil lil))
            )
          )
        )
        ((and ilil (equal (caadr ilil) (caddr ilil) 1e-6))
          (cond
            ((and (not (equal (caadr ilil) (caar ilil) 1e-6)) (not (equal (caadr ilil) (cadar ilil) 1e-6)))
                  (setq lil (processlil ilil lil))
            )
            ((equal (caadr ilil) (caar ilil) 1e-6)
                    (setq lil (processlil ilil lil))
            )
            ((equal (caadr ilil) (cadar ilil) 1e-6)
                    (setq ilil (subst (assoc (caadr ilil) lil) (car ilil) ilil))
                    (setq lil (processlil ilil lil))
            )
          )
        )
        ((and ilil (equal (cadadr ilil) (caddr ilil) 1e-6))
          (cond
            ((and (not (equal (cadadr ilil) (caar ilil) 1e-6)) (not (equal (cadadr ilil) (cadar ilil) 1e-6)))
                  (setq ilil (subst (assoc (cadadr ilil) lil) (cadr ilil) ilil))
                  (setq lil (processlil ilil lil))
            )
            ((equal (cadadr ilil) (caar ilil) 1e-6)
                    (setq ilil (subst (assoc (cadadr ilil) lil) (cadr ilil) ilil))
                    (setq lil (processlil ilil lil))
            )
            ((equal (cadadr ilil) (cadar ilil) 1e-6)
                    (setq ilil (subst (assoc (cadadr ilil) lil) (cadr ilil) ilil))
                    (setq ilil (subst (assoc (cadar ilil) lil) (car ilil) ilil))
                    (setq lil (processlil ilil lil))
            )
          )
        )
        (t (setq done t))
      )
    )
    (setq r (mapcar (function car) lil))
    (setq lil nil)
    r
  )

  (defun chkinters-p (pl / r lil)
    (setq lil (mapcar (function list) pl (append (cdr pl) (list (car pl)))))
    (setq r
          (vl-some
            (function (lambda (x)
                              (vl-some
                                (function (lambda (y)
                                                  (and
                                                    (not (equal (car x) (car y) 1e-6))
                                                    (not (equal (car x) (cadr y) 1e-6))
                                                    (not (equal (cadr x) (car y) 1e-6))
                                                    (not (equal (cadr x) (cadr y) 1e-6))
                                                    (or
                                                      (inters (car x) (cadr x) (car y) (cadr y))
                                                      (collinear-p (car x) (car y) (cadr x))
                                                      (collinear-p (car x) (cadr y) (cadr x))
                                                      (collinear-p (car y) (car x) (cadr y))
                                                      (collinear-p (car y) (cadr x) (cadr y))
                                                    )
                                                  )
                                          )
                                )
                                (vl-remove x lil)
                              )
                      )
            )
            lil
          )
    )
    r
  )

  (defun collinear-p (p1 p p2)
    (equal (distance p1 p2) (+ (distance p1 p) (distance p p2)) 1e-6)
  )

  ;; Convex Hull  -  Lee Mac
  ;; Implements the Graham Scan Algorithm to return the Convex Hull of a list of points.
  ;; Mod by M.R.  -  uses (car-sort) and (_vl-sort) subs...

  (defun MR:ConvexHull-ptsonHull (lst / ch p0 lstl)
    (cond
      ((< (length lst) 4) (_vl-sort lst (function (lambda (a b) (if (= (cadr a) (cadr b)) (< (car a) (car b)) (< (cadr a) (cadr b)))))))
      ((setq p0 (car lst))
        (foreach p1 (cdr lst)
          (if (or (< (cadr p1) (cadr p0)) (and (= (cadr p1) (cadr p0)) (< (car p1) (car p0))))
            (setq p0 p1)
          )
        )
        (setq lst (vl-remove p0 lst))
        (setq lst (append (list p0) lst))
        (setq lst
              (_vl-sort lst
                        (function
                          (lambda (a b / c d)
                            (if (or (equal (setq c (angle p0 a)) (setq d (angle p0 b)) 1e-8) (and (or (equal c 0.0 1e-8) (equal c (* 2 pi) 1e-8)) (or (equal d 0.0 1e-8) (equal d (* 2 pi) 1e-8))))
                              (< (distance (list (car p0) (cadr p0)) a) (distance (list (car p0) (cadr p0)) b))
                              (< c d)
                            )
                          )
                        )
              )
        )
        (setq lstl (vl-remove-if-not (function (lambda (x) (equal (angle p0 (last lst)) (angle p0 x) 1e-8))) lst))
        (setq lst (vl-remove-if (function (lambda (x) (equal (angle p0 (last lst)) (angle p0 x) 1e-8))) lst))
        (setq lstl (_vl-sort lstl (function (lambda (a b) (> (distance (list (car p0) (cadr p0)) a) (distance (list (car p0) (cadr p0)) b))))))
        (setq lst (append lst lstl))
        (setq ch (list (cadr lst) (car lst)))
        (foreach pt (cddr lst)
          (if (equal pt (last lst))
            (setq ch (cons pt ch))
            (if (or (equal (angle (car ch) pt) (car-sort (mapcar (function (lambda (x) (angle (car ch) x))) (member pt lst)) (function <)) 1e-6) (equal (distance pt (cadr ch)) (+ (distance pt (car ch)) (distance (car ch) (cadr ch))) 1e-6))
              (setq ch (cons pt ch))
            )
          )
        )
         (reverse ch)
      )
    )
  )

  (defun _vl-sort (l f / *q* ll ff gg)
    (if (= (type f) 'sym)
      (setq f (eval f))
    )
    (while (setq *q* (car l))
      (setq ll
        (if (null ll)
          (cons *q* ll)
          (cond
            ((apply f (list (last ll) *q*))
                    (append ll (list *q*))
            )
            ((apply f (list *q* (car ll)))
                    (cons *q* ll)
            )
            (t
              (setq ff nil)
              (setq gg (apply (function append) (append (mapcar (function (lambda (*xxx* *yyy*) (if (null ff) (if (apply f (list *q* *yyy*))
                                                                                    (progn
                                                                                      (setq ff t) (list *xxx* *q*)
                                                                                    )
                                                                                    (list *xxx*)
                                                                                  )
                                                                            (list *xxx*)
                                                                          )
                                                                )
                                                        )
                                                ll (cdr ll)
                                                )
                              (list (list (last ll)))
                              )
                       )
              )
              (if (null ff)
                (append ll (list *q*))
                gg
              )
            )
          )
        )
      )
      (setq l (cdr l))
    )
    ll
  )

  (defun mindist-eea-MR (l / f d q)

    (defun f (p l / di)
      (while l
        (if (equal p (car l) (+ d 1e-8))
          (cond
            ((= (setq di (distance p (car l))) d) (setq q (list p (car l))))
            ((< di d)
                (setq d di
                      q (list p (car l))
                )
            )
          )
        )
        (setq l (cdr l))
      )
    )

    (setq d (distance (car l) (cadr l)))
    (foreach a l
      (f a (cdr l))
      (setq l (cdr l))
    )
    q
  )

  (defun greedy (pl / c p1 p2 lst pp1 pp2)
    (gc)
    (if (vl-every (function null) (mapcar (function caddr) pl))
      (setq pl (mapcar (function (lambda (p) (list (car p) (cadr p) 0.0))) pl))
    )
    (setq lst (mindist-eea-MR pl))
    (setq p1 (car lst) p2 (cadr lst))
    (setq pl (vl-remove-if (function (lambda (x) (vl-some (function (lambda (y) (equal x y 1e-6))) lst))) pl))
    (while pl
      (setq pp1 (car-sort pl (function (lambda (q p) (< (distance p1 q) (distance p1 p))))))
      (setq pp2 (car-sort pl (function (lambda (q p) (< (distance p2 q) (distance p2 p))))))
      (if
        (or
          (< (distance p1 pp1) (distance p2 pp2))
          (equal (distance p1 pp1) (distance p2 pp2) 1e-6)
        )
        (progn
          (if (< (distance (car lst) pp1) (distance (last lst) pp1))
            (setq lst (cons pp1 lst))
            (setq lst (append lst (list pp1)))
          )
          (setq pl (vl-remove pp1 pl))
        )
        (progn
          (if (< (distance (car lst) pp2) (distance (last lst) pp2))
            (setq lst (cons pp2 lst))
            (setq lst (append lst (list pp2)))
          )
          (setq pl (vl-remove pp2 pl))
        )
      )
      (setq p1 (car lst) p2 (last lst))
    )
    lst
  )

  (defun grid (l / ucsf a b bb d1 d2 a1 a2 e ll p pl an f)
    (gc)
    ;;;(setq l (_vl-sort l (function (lambda ( a b ) (< (angle a b) (angle b a)))))) ;;; already sorted in main section ;;;
    (exe (list "_.UCS" "_3P" "_non" (car l) "_non" (cadr l) "_non" (polar (car l) (+ (angle (car l) (cadr l)) (* 0.5 pi)) 1.0)))
    (setq l (mapcar (function (lambda (p) (trans p 0 1))) l))
    (setq ll (last l))
    (setq an 0.0)
    (setq p (car l)
          pl (list p)
          l (cdr l)
    )
    (while l
      (setq l (_vl-sort l (function (lambda (a b) (< (distance p a) (distance p b))))))
      (setq a1 (car l) a2 (cadr l))
      (setq d1 (distance p a1) d2 (if a2 (distance p a2)))
      (if (and d2 (equal d1 d2 1e-6))
        (if (and an (or (equal (angle p a1) an 1e-6) (equal (angle p a1) (rem (+ pi an) (+ pi pi)) 1e-6) (if (or (equal an 0.0 1e-6) (equal an (* 2 pi) 1e-6)) (equal (angle p a1) (* 2 pi) 1e-6))))
          (setq a a1)
          (setq a a2)
        )
        (setq a a1)
      )
      (if (and an (or (equal (angle p a) an 1e-6) (equal (angle p a) (rem (+ pi an) (+ pi pi)) 1e-6) (if (or (equal an 0.0 1e-6) (equal an (* 2 pi) 1e-6)) (equal (angle p a) (* 2 pi) 1e-6))))
        (setq bb a)
        (setq b a)
      )
      (if bb
        (setq b bb)
      )
      (cond
        ((equal a1 ll 1e-6)
                (setq a a1 b a an (* 0.5 pi) f t)
        )
        ((equal a2 ll 1e-6)
                (setq a a2 b a an (* 0.5 pi) f t)
        )
      )
      (setq pl (cons b pl)
            l (vl-remove b l)
            p b
            b nil
            bb nil
      )
      (if f
        (cond
          ((= an 0.0)
              (setq an (* 0.5 pi))
          )
          (t
            (setq an 0.0)
          )
        )
        (cond
          ((and (= an 0.0) (equal (car p) (car ll) 1e-6))
                (setq an (* 0.5 pi))
          )
          ((and (= an (* 0.5 pi)) (equal (cadr p) (cadr ll) 1e-6))
                (setq an 0.0)
          )
          ((and (= an (* 0.5 pi)) (equal (car p) (car ll) 1e-6))
                (setq an 0.0)
          )
          ((and (= an 0.0) (equal (cadr p) (cadr ll) 1e-6))
                (setq an (* 0.5 pi))
          )
        )
      )
    )
    (setq pl (reverse pl))
    (setq e nil
          l pl
          ll l
    )
    (while (and (not e) ll)
      (setq e t
            ll l
      )
      (while (and e ll)
        (setq ll (if (listp (caar ll))
                   ll
                   (mapcar (function list) (cons (last ll) ll) ll)
                 )
              a (car ll)
              pl (vl-remove-if (function (lambda (b) (or (member (car a) b) (member (cadr a) b))))
                               (cdr ll)
                 )
              ll (cdr ll)
        )
        (while (and pl (setq b (car pl)) (not (inters (car a) (cadr a) (car b) (cadr b))))
          (setq pl (cdr pl))
        )
        (if pl
          (progn  ;;; [(car a) (cadr a) ... ->end] + ((car b) (cadr b)) - in middle of concatenated l + [start ... ->] ... (car a) - don't exist - it was (cdr-ed)
                    (setq l (append (member (car a) l) (reverse (cdr (member (car a) (reverse l)))))
                          l (append (list (car a)) (member (car b) (reverse (cdr l))) (member (cadr b) l))  ;;; [(car a)] + [(car b) + end<- ... (cadr a)] + [(cadr b) + start ... ->]
                          e nil
                    )
          )
        )
      )
    )
    (setq l (mapcar (function (lambda (p) (trans p 1 0))) l))
    (exe (list "_.UCS" "_P"))
    l
  )

  (defun unique (lst / a ll)
    (while (setq a (car lst))
      (if (vl-some (function (lambda (x) (equal x a 1e-6))) (cdr lst))
        (setq ll (cons a ll) lst (vl-remove-if (function (lambda (x) (equal x a 1e-6))) (cdr lst)))
        (setq ll (cons a ll) lst (cdr lst))
      )
    )
    (reverse ll)
  )
;|
  (defun foo1 (plst / l)
    (gc)
    (setq l plst)
    (while
      (and
        (null xxx1)
        (vl-some
          (function (lambda (a b / l1 l2 c)
            (setq l1 l  c (vl-some
                            (function (lambda (x)
                              (if (< (distance a x) (distance a b)) x)
                            ))
                            (vl-remove a (vl-remove b l))
                          )
            )
            (if c
              (setq l2
                (append
                  (reverse (member a (reverse (vl-remove c l))))
                  (list c)
                  (if (/= (vl-position a l) (1- (length l)))
                    (member b (vl-remove c l))
                  )
                )
              )
              (setq l2 nil)
            )
            (if
              (and
                l2
                (or
                  (< (length (unique l2)) (length l2))
                  (< (length l2) (length l1))
                )
              )
              (setq xxx1 (list l1 l2 c (list a b)))
            )
            (if
              (and
                l2
                (not (chkinters-p l2))
                (> (get-closedpolygon-length l1) (get-closedpolygon-length l2))
              )
              (setq l l2)
              (if l2
                (progn
                  (setq l (append (cdr l) (list (car l))))
                  nil
                )
              )
            )
          ))
          (if (chkinters-p l)
            (setq l (chkinters l))
            l
          )
          (append (cdr l) (list (car l)))
        )
      )
    )
    l
  )
|;
  (defun foo2 (plst / l)
    (gc)
    (setq l plst)
    (while
      (and
        (null xxx2)
        (vl-some
          (function (lambda (a b / l1 l2 c d e)
            (setq l1 l  c (vl-some
                            (function (lambda (x)
                              (if
                                (<
                                  (- 
                                    (+ (distance a x) (distance x b))
                                    (distance a b)
                                  )
                                  (- 
                                    (+ 
                                      (distance (setq d (if (= (vl-position x l) 0) (last l) (nth (1- (vl-position x l)) l))) x)
                                      (distance x (setq e (if (= (vl-position x l) (1- (length l))) (car l) (nth (1+ (vl-position x l)) l))))
                                    )
                                    (distance d e)
                                  )
                                )
                                x
                              )
                            ))
                            (vl-remove a (vl-remove b l))
                          )
            )
            (if c
              (setq l2
                (append
                  (reverse (member a (reverse (vl-remove c l))))
                  (list c)
                  (if (/= (vl-position a l) (1- (length l)))
                    (vl-remove c (member b l))
                  )
                )
              )
              (setq l2 nil)
            ) 
            (if
              (and
                l2
                (or
                  (< (length (unique l2)) (length l2))
                  (< (length l2) (length l1))
                )
              )
              (setq xxx2 (list l1 l2 c d e (list a b)))
            )
            (if
              (and
                l2
                (not (chkinters-p l2))
                (> (get-closedpolygon-length l1) (get-closedpolygon-length l2))
              )
              (setq l l2)
              (if l2
                (progn
                  (setq l (append (cdr l) (list (car l))))
                  nil
                )
              )
            )
          ))
          (if (chkinters-p l)
            (setq l (chkinters l))
            l
          )
          (append (cdr l) (list (car l)))
        )
      )
    )
    l
  )

  (defun foo3 (plst / l)
    (gc)
    (setq l plst)
    (while
      (and
        (null xxx3)
        (vl-some
          (function (lambda (a b c / l1 l2)
            (setq l1 l l2 (append
                            (cond
                              ( (= (vl-position a l) (- (length l) 2))
                                (cdr (reverse (member (cdr (reverse l)))))
                              )
                              ( (= (vl-position a l) (1- (length l)))
                                (cddr l)
                              )
                              ( t (reverse (member a (reverse l))) )
                            )
                            (list c b) (cdddr (member a l))
                          )
            )
            (if
              (or
                (< (length (unique l2)) (length l2))
                (< (length l2) (length l1))
              )
              (setq xxx3 (list l1 l2 (list a b c)))
            )
            (if
              (and
                (not (chkinters-p l2))
                (> (get-closedpolygon-length l1) (get-closedpolygon-length l2))
              ) 
              (setq l l2)
              (progn
                (setq l (append (cdr l) (list (car l))))
                nil
              )
            )
          ))
          (if (chkinters-p l)
            (setq l (chkinters l))
            l
          )
          (append (cdr l) (list (car l)))
          (append (cddr l) (list (car l) (cadr l)))
        )
      )
    )
    l
  )

  (defun foo4 (plst / l)
    (gc)
    (setq l plst)
    (while
      (and
        (null xxx4)
        (vl-some
          (function (lambda (a b c / l1 l2 edge)
            (setq l1 l edge (vl-some
                              (function (lambda (x)
                                (if
                                  (<
                                    (- 
                                      (+ (distance (car x) b) (distance b (cadr x)))
                                      (distance (car x) (cadr x))
                                    )
                                    (-
                                      (+ (distance a b) (distance b c))
                                      (distance a c)
                                    )
                                  )
                                  x
                                )
                              ))
                              (vl-remove (list a b)
                                (vl-remove (list b c)
                                  (mapcar (function list)
                                    (append l l)
                                    (append
                                      (append (cdr l) (list (car l)))
                                      (append (cdr l) (list (car l)))
                                    )
                                  )
                                )
                              )
                            )
            )
            (if edge
              (setq l2
                (append
                  (if (/= (vl-position (car edge) l) (1- (length l)))
                    (reverse (member (car edge) (reverse (vl-remove b l))))
                  )
                  (list b)
                  (member (cadr edge) (vl-remove b l))
                )
              )
              (setq l2 nil)
            )
            (if
              (and
                l2
                (or
                  (< (length (unique l2)) (length l2))
                  (< (length l2) (length l1))
                )
              )
              (setq xxx4 (list l1 l2 edge (list a b c)))
            )
            (if
              (and
                l2
                (not (chkinters-p l2))
                (> (get-closedpolygon-length l1) (get-closedpolygon-length l2))
              )
              (setq l l2)
              (if l2
                (progn
                  (setq l (append (cdr l) (list (car l))))
                  nil
                )
              )
            )
          ))
          (if (chkinters-p l)
            (setq l (chkinters l))
            l
          )
          (append (cdr l) (list (car l)))
          (append (cddr l) (list (car l) (cadr l)))
        )
      )
    )
    l
  )

  (defun foo5 (plst / l)
    (gc)
    (setq l plst)
    (while
      (and
        (null xxx5)
        (vl-some
          (function (lambda (a b c / l1 l2 edge x)
            (setq l1 l edge (vl-some
                              (function (lambda (x)
                                (if
                                  (and
                                    (not (equal (car x) b 1e-6))
                                    (not (equal b (cadr x) 1e-6))
                                    (< 
                                      (- 
                                        (+ (distance (car x) b) (distance b (cadr x)))
                                        (distance (car x) (cadr x))
                                      )
                                      (-
                                        (+ (distance a b) (distance b c))
                                        (distance a c)
                                      )
                                    )
                                  )
                                  x
                                )
                              ))
                              (mapcar (function list)
                                (append l l)
                                (append
                                  (append (cddr l) (list (car l) (cadr l)))
                                  (append (cddr l) (list (car l) (cadr l)))
                                )
                              )
                            )
            )
            (if edge
              (setq x
                (vl-some
                  (function (lambda (y)
                    (if
                      (< 
                        (vl-position (car edge) (append l l))
                        (vl-position y (append l l))
                        (vl-position (cadr edge) (append l l))
                      )
                      y
                    )
                  ))
                  (append l l)
                )
              )
            )
            (if (and edge x)
              (setq l2
                (append
                  (if
                    (/= 
                      (vl-position (car edge) l)
                      (1- (length l))
                    )
                    (reverse (member (car edge) (reverse (vl-remove x (vl-remove b l)))))
                  )
                  (list b (cadr edge))
                  (cons x (cdr (member (cadr edge) (vl-remove x (vl-remove b l)))))
                )
              )
              (setq l2 nil)
            )
            (if
              (and
                l2
                (or
                  (< (length (unique l2)) (length l2))
                  (< (length l2) (length l1))
                )
              )
              (setq xxx5 (list l1 l2 edge x (list a b c)))
            )
            (if
              (and
                l2
                (not (chkinters-p l2))
                (> (get-closedpolygon-length l1) (get-closedpolygon-length l2))
              )
              (setq l l2)
              (if l2
                (progn
                  (setq l (append (cdr l) (list (car l))))
                  nil
                )
              )
            )
          ))
          (if (chkinters-p l)
            (setq l (chkinters l))
            l
          )
          (append (cdr l) (list (car l)))
          (append (cddr l) (list (car l) (cadr l)))
        )
      )
    )
    l
  )

  (defun fff (plst / l ll d0 d bb xx)
    (gc)
    (setq l plst)
    (setq d0 1e+308 d (get-closedpolygon-length l))
    (while (> d0 d)
      (setq d0 d)
      (if (chkinters-p l)
        (setq l (chkinters l))
        l
      )
      (mapcar
        (function (lambda (a b c)
          (if
            (vl-some
              (function (lambda (x)
                (if
                  (and
                    (not (equal a x 1e-6))
                    (not (equal b x 1e-6))
                    (not (equal c x 1e-6))
                    (<
                      (+ (distance a x) (distance x c))
                      (+ (distance
                           (cond
                             ( (equal x (last l) 1e-6)
                               (nth (- (length l) 2) l)
                             )
                             ( (equal x (car l) 1e-6)
                               (last l)
                             )
                             ( t (nth (1- (vl-position x l)) l) )
                           )
                           x
                         )
                         (distance
                           x
                           (cond
                             ( (equal x (last l) 1e-6)
                               (car l)
                             )
                             ( (equal x (car l) 1e-6)
                               (cadr l)
                             )
                             ( t (nth (1+ (vl-position x l)) l) )
                           )
                         )
                      )
                    )
                  )
                  (progn
                    (setq bb b)
                    (setq xx x)
                  )
                )
              ))
              (append l l)
            )
            (setq ll
              (mapcar
                (function (lambda ( p )
                  (cond
                    ( (equal p xx 1e-6)
                      bb
                    )
                    ( (equal p bb 1e-6)
                      xx
                    )
                    ( t p )
                  )
                ))
                l
              )
            )
          )
        ))
        l
        (append (cdr l) (list (car l)))
        (append (cddr l) (list (car l) (cadr l)))
      )
      (if (and ll (< (get-closedpolygon-length ll) (get-closedpolygon-length l)))
        (setq d (get-closedpolygon-length ll) l ll)
        (setq d (get-closedpolygon-length l))
      )
    )
    l
  )

  (defun generic (l / ch inpts lil d p lilp lip)
    (gc)
    (setq ch (MR:ConvexHull-ptsonHull l))
    (setq inpts (vl-remove-if (function (lambda (x) (vl-position x ch))) l))
    (while inpts
      (setq lil (mapcar (function list) ch (append (cdr ch) (list (car ch)))))
      (foreach li lil
        (setq d (distance (car li) (cadr li)))
        (setq p (car-sort inpts (function (lambda (a b) (< (- (+ (distance (car li) a) (distance a (cadr li))) d) (- (+ (distance (car li) b) (distance b (cadr li))) d))))))
        (setq lilp (cons (list li p) lilp))
      )
      (setq lip (car-sort lilp (function (lambda (a b) (< (- (+ (distance (caar a) (cadr a)) (distance (cadr a) (cadar a))) (distance (caar a) (cadar a))) (- (+ (distance (caar b) (cadr b)) (distance (cadr b) (cadar b))) (distance (caar b) (cadar b))))))))
      (setq lil (subst (list (caar lip) (cadr lip) (cadar lip)) (car lip) lil))
      (setq ch (unique (apply (function append) lil)))
      (setq inpts (vl-remove (cadr lip) inpts))
      (setq lilp nil)
    )
    ch
  )

  (defun mchull (lst n / ch chh ll lll li llst)
    (gc)
    (while (setq ch (MR:ConvexHull-ptsonHull lst))
      (setq chh (cons ch chh))
      (setq lst (vl-remove-if (function (lambda (p) (vl-position p ch))) lst))
    )
    (while (and (setq ll (car chh)) (cadr chh))
      (setq chh (cdr chh))
      (setq lll (car chh))
      (foreach p lll
        (setq li (car-sort (mapcar (function list) ll (append (cdr ll) (list (car ll)))) (function (lambda (a b) (< (- (+ (distance (car a) p) (distance (cadr a) p)) (distance (car a) (cadr a))) (- (+ (distance (car b) p) (distance (cadr b) p)) (distance (car b) (cadr b))))))))
        (setq ll (unique (apply (function append) (subst (list (car li) p (cadr li)) (list (car li)) (mapcar (function list) ll)))))
      )
      (if (not llst)
        (setq llst ll)
        (if (< (length (append ll llst)) n)
          (setq llst (append ll llst))
          (setq llst (foo (append ll llst) n))
        )
      )
      (setq lll nil)
    )
    (if (and ll llst)
      (foreach p ll
        (setq li (car-sort (mapcar (function list) llst (append (cdr llst) (list (car llst)))) (function (lambda (a b) (< (- (+ (distance (car a) p) (distance (cadr a) p)) (distance (car a) (cadr a))) (- (+ (distance (car b) p) (distance (cadr b) p)) (distance (car b) (cadr b))))))))
        (setq llst (unique (apply (function append) (subst (list (car li) p (cadr li)) (list (car li)) (mapcar (function list) llst)))))
      )
    )
    (if (< (length llst) n)
      llst
      (foo llst n)
    )
  )

  (defun makelw (lst)
    (entmake
      (append
        (list
          (cons 0 "LWPOLYLINE")
          (cons 100 "AcDbEntity")
          (cons 100 "AcDbPolyline")
          (cons 90 (length lst))
          (cons 70 (1+ (* 128 (getvar (quote plinegen)))))
          (cons 38 0.0)
        )
        (mapcar (function (lambda (x) (cons 10 x))) lst)
        (list (list 210 0.0 0.0 1.0))
      )
    )
  )


  (setq wcs (tttt t))
  (setq n 9)
  (while (> n 8)
    (initget 4)
    (setq n
      (cond
        ((getint "\nSpecify depth for permutations <5> - 0 is allowed - if it fails next put 1 : ")) (5)
      )
    )
    (if (> n 8)
      (prompt "\nCrazy input - maximal value of n is 8...")
    )
  )
  (initget "Yes No")
  (setq flag
    (cond
      ((getkword "\nDo you want mchull turned on [Yes / No] <No> : ")) ("No")
    )
  )
  (initget "Yes No")
  (setq flagg
    (cond
      ((getkword "\nDo you want (foo*) functions turned on [Yes / No] <Yes> : ")) ("Yes")
    )
  )
  (prompt "\nSelect 2D points, inserts or circles...")
  (if (setq ss (ssget (list (cons 0 "POINT,INSERT,CIRCLE"))))
    (progn
      (setq ti (car (_vl-times)))
      (repeat (setq i (sslength ss))
        (setq pl (cons (mapcar (function +) (list 0.0 0.0) (trans (cdr (assoc 10 (entget (ssname ss (setq i (1- i)))))) 0 1)) pl))
      )
      (setq pl (_vl-sort pl (function (lambda (a b) (< (angle a b) (angle b a))))))
      (setq pl1 (greedy pl))
      (if (and pl1 (chkinters-p pl1)) (setq pl1 (chkinters pl1)))
      (setq pl2 (grid pl))
      (if (and pl2 (chkinters-p pl2)) (setq pl2 (chkinters pl2)))
      (setq pl3 (generic pl))
      (if (and pl3 (chkinters-p pl3)) (setq pl3 (chkinters pl3)))

      ; (if (= flag "Yes")
        ; (if (= flagg "Yes")
          ; (progn
            ; (setq pl4 (mchull pl n))
            ; (if (and pl4 (chkinters-p pl4)) (setq pl4 (chkinters pl4)))
            ; (setq pl5 (fff (foo5 (foo4 (foo3 (foo2 (foo1 (foo pl4 n))))))))
            ; (if (and pl5 (chkinters-p pl5)) (setq pl5 (chkinters pl5)))
          ; )
        ; )
      ; )
      ; (if (= flagg "Yes")
        ; (progn
          ; (setq pl6 (foo5 (foo4 (foo3 (foo2 (foo1 (foo pl3 n)))))))
          ; (if (and pl6 (chkinters-p pl6)) (setq pl6 (chkinters pl6)))
          ; (setq pl7 (foo5 (foo4 (foo3 (foo2 (foo1 (foo pl2 n)))))))
          ; (if (and pl7 (chkinters-p pl7)) (setq pl7 (chkinters pl7)))
          ; (setq pl8 (foo5 (foo4 (foo3 (foo2 (foo1 (foo pl1 n)))))))
          ; (if (and pl8 (chkinters-p pl8)) (setq pl8 (chkinters pl8)))
          ; (setq pl9 (fff pl6))
          ; (if (and pl9 (chkinters-p pl9)) (setq pl9 (chkinters pl9)))
        ; )
      ; )

      (if (= flag "Yes")
        (if (= flagg "Yes")
          (progn
            (setq pl4 (mchull pl n))
            (if (and pl4 (chkinters-p pl4)) (setq pl4 (chkinters pl4)))
            (setq pl5 (fff (foo5 (foo4 (foo3 (foo2 (foo pl4 n)))))))
            (if (and pl5 (chkinters-p pl5)) (setq pl5 (chkinters pl5)))
          )
        )
      )
      (if (= flagg "Yes")
        (progn
          (setq pl6 (foo5 (foo4 (foo3 (foo2 (foo pl3 n))))))
          (if (and pl6 (chkinters-p pl6)) (setq pl6 (chkinters pl6)))
          (setq pl7 (foo5 (foo4 (foo3 (foo2 (foo pl2 n))))))
          (if (and pl7 (chkinters-p pl7)) (setq pl7 (chkinters pl7)))
          (setq pl8 (foo5 (foo4 (foo3 (foo2 (foo pl1 n))))))
          (if (and pl8 (chkinters-p pl8)) (setq pl8 (chkinters pl8)))
          (setq pl9 (fff pl6))
          (if (and pl9 (chkinters-p pl9)) (setq pl9 (chkinters pl9)))
        )
      )
      (setq pl (car-sort (vl-remove nil (list pl9 pl8 pl7 pl6 pl5 pl4 pl3 pl2 pl1)) (function (lambda (a b) (< (get-closedpolygon-length a) (get-closedpolygon-length b))))))
      (makelw pl)
      (prompt "\nDistance - path length : ") (princ (rtos (get-closedpolygon-length pl) 2 20))
      (prompt "\nElapsed time : ") (princ (rtos (- (car (_vl-times)) ti) 2 20)) (prompt " milliseconds...")
      (prompt "\nFor UNDO - type \"UNDO\" - \"Back\" option...")
    )
  )
  (*error* nil)
)