(defun c:TSP-MR-2D (/ *error* tttt wcs initvalueslst ucsf ti processlw _do-events radial car-sort _vl-sort get-closedpolygon-length chkinters chkinters-p collinear-p MR:ConvexHull-ptsonHull mindist-eea-MR greedy grid generic unique fff makelw ch ss i pl pl1 pl2 pl3 pl4 pl5 pl6 n ch)

  (cond
    ( (= "BRICSCAD" (getvar (quote program)))
      (if (findfile "VLCE_NP_Brx23.brx")
        (arxload (findfile "VLCE_NP_Brx23.brx"))
        (prompt "\nVLCE_NP_Brx23.brx not found in SFSP...")
      )
    )
    ( t
      (if (findfile "VLCE_NP_Arx24.arx")
        (arxload (findfile "VLCE_NP_Arx24.arx"))
        (prompt "\nVLCE_NP_Arx24.arx not found in SFSP...")
      )
    )
  )

  (defun *error* (m)
    (if wcs
      (if ucsf
        (while
          (not
            (and
              (equal (getvar (quote ucsxdir)) (car ucsf) 1e-6)
              (equal (getvar (quote ucsydir)) (cadr ucsf) 1e-6)
              (equal (trans (list 0.0 0.0 1.0) 1 0 t) (caddr ucsf) 1e-6)
            )
          )
          (exe (list "_.UCS" "_P"))
        )
      )
    )
    (while (= 8 (logand 8 (getvar (quote undoctl))))
      (if (not (exe (list "_.UNDO" "_E")))
        (if doc
          (vla-endundomark doc)
        )
      )
    )
    (if initvalueslst
      (mapcar (function apply_cadr->car) initvalueslst)
    )
    (foreach fun (list (quote tttt) (quote vl-load) (quote exe) (quote cmdfun) (quote cmderr) (quote catch_cont) (quote apply_cadr->car) (quote ftoa))
      (setq fun nil)
    )
    (if doc
      (vla-regen doc acactiveviewport)
    )
    (if m
      (prompt m)
    )
    (princ)
  )

  (defun tttt (wcs / sysvarpreset sysvarlst sysvarvals)  ;;; wcs (T/nil) ;;; cad, doc, alo, spc - global variables (Visual Lisp main VLA-OBJECT pointers) ;;; vl-load exe cmdfun cmderr catch_cont apply_cadr->car ftoa - library sub functions common for standard template initialization ;;;

    (defun vl-load nil
      (or cad
        (if vlax-get-acad-object
          (setq cad (vlax-get-acad-object))
          (progn
            (vl-load-com)
            (setq cad (vlax-get-acad-object))
          )
        )
      )
      (or doc (setq doc (vla-get-activedocument cad)))
      (or alo (setq alo (vla-get-activelayout doc)))
      (or spc (setq spc (vla-get-block alo)))
    )

    ;;; sometimes not needed to use/initialize AxiveX Visual Lisp extensions - (comment/uncomment) following line ;;;
    (or (and cad doc alo spc) (vl-load))

    (defun exe (tokenslist)
      ( (lambda (tokenslist / ctch)
          (if (vl-catch-all-error-p (setq ctch (cmdfun tokenslist t)))
            (progn
              (cmderr tokenslist)
              (catch_cont ctch)
            )
            (progn
              (while (< 0 (getvar (quote cmdactive)))
                (vl-cmdf "")
              )
              t
            )
          )
        )
        tokenslist
      )
    )

    (defun cmdfun (tokenslist flag / ctch)  ;;; tokenslist - command parameters list of strings ;;; flag - if "t" specified, upon successful execution returns t, otherwise if "nil" specified, return is always nil no matter what outcome of function execution is - it should be successful anyway if specified tokenslist was hardcoded correctly... ;;;
      (if command-s
        (if flag
          (if (not (vl-catch-all-error-p (setq ctch (vl-catch-all-apply (function command-s) tokenslist))))
            flag
            ctch
          )
          (if (vl-catch-all-error-p (setq ctch (vl-catch-all-apply (function command-s) tokenslist)))
            ctch
          )
        )
        (if flag
          (if (not (vl-catch-all-error-p (setq ctch (vl-catch-all-apply (function vl-cmdf) tokenslist))))
            flag
            ctch
          )
          (if (vl-catch-all-error-p (setq ctch (vl-catch-all-apply (function command) tokenslist)))
            ctch
          )
        )
      )
    )

    (defun cmderr (tokenslist)  ;;; tokenslist - list of tokens representing command syntax at which used (cmdfun) failed with successful execution ;;;
      (prompt (strcat "\ncommand execution failure... error at used command tokenslist : " (vl-prin1-to-string tokenslist)))
    )

    (defun catch_cont (ctch / gr)
      (prompt "\nleft mouse click to continue or enter to generate catch error - ESC to break...")
      (while
        (and
          (vl-catch-all-error-p (or ctch (setq ctch (vl-catch-all-apply (function /) (list 1 0)))))
          (setq gr (grread))
          (/= (car gr) 3)
          (not (equal gr (list 2 13)))
        )
      )
      (if (vl-catch-all-error-p ctch)
        ctch
      )
    )

    (defun apply_cadr->car (sysvarvaluepair / ctch)
      (setq ctch (vl-catch-all-apply (function setvar) sysvarvaluepair))
      (if (vl-catch-all-error-p ctch)
        (progn
          (prompt (strcat "\ncatched error on setting system variable : " (vl-prin1-to-string (vl-symbol-name (car sysvarvaluepair))) " with value : " (vl-prin1-to-string (cadr sysvarvaluepair))))
          (catch_cont ctch)
        )
      )
    )

    (defun ftoa (n / m a s b)
      (if (numberp n)
        (progn
          (setq m (fix ((if (< n 0) - +) n 1e-8)))
          (setq a (abs (- n m)))
          (setq m (itoa m))
          (setq s "")
          (while (and (not (equal a 0.0 1e-6)) (setq b (fix (* a 10.0))))
            (setq s (strcat s (itoa b)))
            (setq a (- (* a 10.0) b))
          )
          (if (= (type n) (quote int))
            m
            (if (= s "")
              m
              (if (and (= m "0") (< n 0))
                (strcat "-" m "." s)
                (strcat m "." s)
              )
            )
          )
        )
      )
    )

    (setq sysvarpreset
      (list
        (list (quote cmdecho) 0)
        (list (quote 3dosmode) 0)
        (list (quote osmode) 0)
        (list (quote unitmode) 0)
        (list (quote cmddia) 0)
        (list (quote ucsvp) 0)
        (list (quote ucsortho) 0)
        (list (quote projmode) 0)
        (list (quote orbitautotarget) 0)
        (list (quote insunits) 0)
        (list (quote hpseparate) 0)
        (list (quote hpgaptol) 0)
        (list (quote halogap) 0)
        (list (quote edgemode) 0)
        (list (quote pickdrag) 0)
        (list (quote qtextmode) 0)
        (list (quote dragsnap) 0)
        (list (quote angdir) 0)
        (list (quote aunits) 0)
        (list (quote limcheck) 0)
        (list (quote gridmode) 0)
        (list (quote nomutt) 0)
        (list (quote apbox) 0)
        (list (quote attdia) 0)
        (list (quote blipmode) 0)
        (list (quote copymode) 0)
        (list (quote circlerad) 0.0)
        (list (quote filletrad) 0.0)
        (list (quote filedia) 1)
        (list (quote autosnap) 1)
        (list (quote objectisolationmode) 1)
        (list (quote highlight) 1)
        (list (quote lispinit) 1)
        (list (quote layerpmode) 1)
        (list (quote fillmode) 1)
        (list (quote dragmodeinterrupt) 1)
        (list (quote dispsilh) 1)
        (list (quote fielddisplay) 1)
        (list (quote deletetool) 1)
        (list (quote delobj) 1)
        (list (quote dblclkedit) 1)
        (list (quote attreq) 1)
        (list (quote explmode) 1)
        (list (quote frameselection) 1)
        (list (quote ltgapselection) 1)
        (list (quote pickfirst) 1)
        (list (quote plinegen) 1)
        (list (quote plinetype) 1)
        (list (quote peditaccept) 1)
        (list (quote solidcheck) 1)
        (list (quote visretain) 1)
        (list (quote regenmode) 1)
        (list (quote celtscale) 1.0)
        (list (quote ltscale) 1.0)
        (list (quote osnapcoord) 2)
        (list (quote grips) 2)
        (list (quote dragmode) 2)
        (list (quote lunits) 2)
        (list (quote pickstyle) 3)
        (list (quote navvcubedisplay) 3)
        (list (quote pickauto) 3)
        (list (quote draworderctl) 3)
        (list (quote expert) 5)
        (list (quote auprec) 6)
        (list (quote luprec) 6)
        (list (quote pickbox) 6)
        (list (quote aperture) 6)
        (list (quote osoptions) 7)
        (list (quote dimzin) 8)
        (list (quote pdmode) 35)
        (list (quote pdsize) -1.5)
        (list (quote celweight) -1)
        (list (quote cecolor) "BYLAYER")
        (list (quote celtype) "ByLayer")
        (list (quote clayer) "0")
      )
    )
    (setq sysvarlst (mapcar (function car) sysvarpreset))
    (setq sysvarvals (mapcar (function cadr) sysvarpreset))
    (setq sysvarvals
      (vl-remove nil
        (mapcar
          (function (lambda (x)
            (if (getvar x)
              (nth (vl-position x sysvarlst) sysvarvals)
            )
          ))
          sysvarlst
        )
      )
    )
    (setq sysvarlst
      (vl-remove-if-not
        (function (lambda (x)
          (getvar x)
        ))
        sysvarlst
      )
    )
    (setq initvalueslst
      (apply (function mapcar)
        (cons (function list)
          (list
            sysvarlst
            (mapcar (function getvar) sysvarlst)
          )
        )
      )
    )
    (apply (function mapcar)
      (cons (function setvar)
        (list
          sysvarlst
          sysvarvals
        )
      )
    )
    (while (= 8 (logand 8 (getvar (quote undoctl))))
      (if (not (exe (list "_.UNDO" "_E")))
        (if doc
          (vla-endundomark doc)
        )
      )
    )
    (if (not (exe (list "_.UNDO" "_M")))
      (if doc
        (vla-startundomark doc)
      )
    )
    (if wcs
      (if (= 0 (getvar (quote worlducs)))
        (progn
          (setq ucsf
            (list
              (getvar (quote ucsxdir))
              (getvar (quote ucsydir))
              (trans (list 0.0 0.0 1.0) 1 0 t)
            )
          )
          (exe (list "_.UCS" "_W"))
        )
      )
    )
    wcs
  )

  (defun processlw ( pl p xpl d / lwx pl pp pll plll )
    (foreach pp (vl-remove-if (function (lambda ( x ) (vl-position x xpl))) pl)
      (setq pll (append (member pp pl) (reverse (cdr (member pp (reverse pl))))))
      (setq pll (list (+ (distance p pp) (distance p (cadr pll))) (append (list pp) (list p) (cdr pll))))
      (setq plll (cons pll plll))
    )
    (setq pll (car-sort plll (function (lambda ( a b ) (if d (< (abs (- d (car a))) (abs (- d (car b)))) (< (apply (function +) (mapcar (function (lambda ( c d ) (distance c d))) (cadr a) (append (cdr (cadr a)) (list (car (cadr a)))))) (apply (function +) (mapcar (function (lambda ( c d ) (distance c d))) (cadr b) (append (cdr (cadr b)) (list (car (cadr b))))))))))))
  )

  (defun _do-events nil
    (gc)
    (repeat 2 (vl-cmdf "_.DELAY" 0) (princ ""))
  )

  (defun radial ( pl / ppp ppl ppll pplll pl xpl xx d pll plll lw lwx lil k ilil pre mid suf )
    (setq ppl pl)
    (while ppl
      (setq ppll (MR:ConvexHull-ptsonHull ppl))
      (setq ppl (vl-remove-if (function (lambda ( x ) (vl-position x ppll))) ppl))
      (setq pplll (cons ppll pplll))
    )
    (setq pplll (reverse pplll))
    (setq pplll (cdr pplll))
    (setq pll (MR:ConvexHull-ptsonHull pl))
    (setq lw
      (entmakex
        (append
          (list
            (cons 0 "LWPOLYLINE")
            (cons 100 "AcDbEntity")
            (cons 100 "AcDbPolyline")
            (cons 90 (length pll))
            (cons 70 (1+ (* 128 (getvar 'plinegen))))
            (cons 38 0.0)
          )
          (mapcar (function (lambda ( x ) (cons 10 x))) pll)
          (list (list 210 0.0 0.0 1.0))
        )
      )
    )
    (setq lwx (entget lw))
    (entupd (cdr (assoc -1 (entmod (append lwx (list (cons 60 1)))))))
    (setq pl (vl-remove-if (function (lambda ( x ) (vl-position x pll))) pl))
    (setq ppp pll ppll (car pplll))
    (while pl
      (foreach p ppll
        (setq plll (cons (processlw ppp p xpl d) plll))
      )
      (setq plll (cadar (vl-sort plll (function (lambda ( a b ) (if d (< (abs (- d (car a))) (abs (- d (car b)))) (< (apply (function +) (mapcar (function (lambda ( c d ) (distance c d))) (cadr a) (append (cdr (cadr a)) (list (car (cadr a)))))) (apply (function +) (mapcar (function (lambda ( c d ) (distance c d))) (cadr b) (append (cdr (cadr b)) (list (car (cadr b)))))))))))))
      (if plll
        (progn
          (entupd
            (cdr
              (assoc -1
                (entmod
                  (setq lwx
                    (append
                      (subst (cons 90 (1+ (cdr (assoc 90 lwx)))) (assoc 90 lwx) (reverse (cdr (member (assoc 10 lwx) (reverse lwx)))))
                      (mapcar (function (lambda ( x ) (cons 10 x))) plll)
                    )
                  )
                )
              )
            )
          )
          (setq pl (vl-remove-if (function (lambda ( x ) (if (vl-position x plll) (setq xx x)))) pl))
          (setq ppll (vl-remove-if (function (lambda ( x ) (vl-position x plll))) ppll))
          (setq pre (cadr (member xx (reverse (append plll plll)))) suf (cadr (member xx (append plll plll))))
          (setq xpl (cons xx xpl))
          (setq d (+ (distance pre xx) (distance xx suf)))
          (if (null ppll)
            (setq pplll (cdr pplll) ppll (car pplll) xpl nil d nil)
          )
          (setq ppp plll)
          (_do-events)
          (redraw lw)
        )
      )
      (setq plll nil)
    )
    (setq pl (mapcar (function cdr) (vl-remove-if (function (lambda ( x ) (/= (car x) 10))) lwx)))
    (setq lil (mapcar (function list) pl (append (cdr pl) (list (car pl)))))
    (setq k -1)
    (while (and (< (setq k (1+ k)) (length lil)) (setq a (nth k lil)))
      (setq ilil (vl-some (function (lambda ( b / ip ) (setq ip (inters (car a) (cadr a) (car b) (cadr b))) (if (and ip (setq ip (mapcar (function +) '(0 0) ip)) (or (and (or (equal ip (car a) 1e-6) (equal ip (cadr a) 1e-6)) (not (equal ip (car b) 1e-6)) (not (equal ip (cadr b) 1e-6))) (and (or (equal ip (car b) 1e-6) (equal ip (cadr b) 1e-6)) (not (equal ip (car a) 1e-6)) (not (equal ip (cadr a) 1e-6))) (and (not (equal ip (car a) 1e-6)) (not (equal ip (cadr a) 1e-6)) (not (equal ip (car b) 1e-6)) (not (equal ip (cadr b) 1e-6))))) (list a b)))) (vl-remove a lil)))
      (if ilil
        (progn
          (setq pre (reverse (cdr (member (car ilil) (reverse lil)))))
          (setq mid (cdr (member (car ilil) lil)))
          (setq mid (cdr (member (cadr ilil) (reverse mid))))
          (setq mid (mapcar (function reverse) mid))
          (setq suf (cdr (member (cadr ilil) lil)))
          (setq lil (append pre (list (list (car (car ilil)) (car (cadr ilil)))) mid (list (list (cadr (car ilil)) (cadr (cadr ilil)))) suf))
          (setq pre nil mid nil suf nil)
          (setq pl (mapcar (function car) lil))
          (entupd
            (cdr
              (assoc -1
                (entmod
                  (append
                    (reverse (cdr (member (assoc 10 lwx) (reverse lwx))))
                    (mapcar (function (lambda ( x ) (cons 10 x))) pl)
                  )
                )
              )
            )
          )
          (_do-events)
          (redraw lw)
          (setq ilil nil k -1)
        )
      )
    )
    (entdel lw)
    pl
  )

  (defun car-sort (lst cmp / rtn)
    (setq rtn (car lst))
    (foreach itm (cdr lst)
      (if (apply cmp (list itm rtn))
        (setq rtn itm)
      )
    )
    rtn
  )

  (defun _vl-sort (lst f / *q* ll ff gg)
    (if (= (type f) 'sym)
      (setq f (eval f))
    )
    (while (setq *q* (car lst))
      (setq ll
        (if (null ll)
          (cons *q* ll)
          (cond
            ( (apply f (list (last ll) *q*))
              (append ll (list *q*))
            )
            ( (apply f (list *q* (car ll)))
              (cons *q* ll)
            )
            ( t
              (setq ff nil)
              (setq gg
                (apply (function append)
                  (append
                    (mapcar
                      (function (lambda (*xxx* *yyy*)
                        (if (null ff)
                          (if (apply f (list *q* *yyy*))
                            (progn
                              (setq ff t) (list *xxx* *q*)
                            )
                            (list *xxx*)
                          )
                          (list *xxx*)
                        )
                      ))
                      ll
                      (cdr ll)
                    )
                    (list (list (last ll)))
                  )
                )
              )
              (if (null ff)
                (append ll (list *q*))
                gg
              )
            )
          )
        )
      )
      (setq lst (cdr lst))
    )
    ll
  )

  (defun get-closedpolygon-length ( lst )
    (apply (function +) (mapcar (function distance) lst (append (cdr lst) (list (car lst)))))
  )

  (defun chkinters (pl / unit v^v processlil _inters done r lill ilil iip lil)

    (defun unit (v / d)
      (if (not (equal (setq d (distance (list 0.0 0.0 0.0) v)) 0.0 1e-8))
        (mapcar
          (function (lambda (x)
            (/ x d)
          ))
          v
        )
        (progn
          (prompt "\nInvalid vector specification - strength near 0.0... Quitting...")
          (exit)
        )
      )
    )

    (defun v^v (u v)
      (list
        (- (* (cadr u) (caddr v)) (* (caddr u) (cadr v)))
        (- (* (caddr u) (car v)) (* (car u) (caddr v)))
        (- (* (car u) (cadr v)) (* (cadr u) (car v)))
      )
    )

    (defun processlil (ilil lil / pre mid suf ret)
      (setq pre (reverse (cdr (member (car ilil) (reverse lil)))))
      (setq mid (cdr (member (car ilil) lil)))
      (setq mid (cdr (member (cadr ilil) (reverse mid))))
      (setq mid (mapcar (function reverse) mid))
      (setq suf (cdr (member (cadr ilil) lil)))
      (setq ret (append pre (list (list (car (car ilil)) (car (cadr ilil)))) mid (list (list (cadr (car ilil)) (cadr (cadr ilil)))) suf))
      ret
    )

    (defun _inters (p1 p2 p3 p4 / v oo ip)
      (if (and bp rad)
        (setq oo bp)
        (setq oo o)
      )
      (setq v (v^v (v^v (mapcar (function -) p1 oo) (mapcar (function -) p2 oo)) (v^v (mapcar (function -) p3 oo) (mapcar (function -) p4 oo))))
      (if (and (equal v (list 0.0 0.0 0.0) 1e-6) (setq ip (inters p1 p2 p3 p4 nil)))
        (setq v (unit (mapcar (function -) oo ip)))
        (if (not (equal v (list 0.0 0.0 0.0) 1e-6))
          (setq v (unit v))
        )
      )
      (and
        ip
        p1
        p2
        p3
        p4
        oo
        v
        (setq ip (inters p1 p2 oo (mapcar (function +) oo (mapcar (function *) v (list 1e+6 1e+6 1e+6))) nil))
        (equal (distance p1 p2) (+ (distance p1 ip) (distance ip p2)) 1e-6)
        (setq ip (inters p3 p4 oo (mapcar (function +) oo (mapcar (function *) v (list 1e+6 1e+6 1e+6))) nil))
        (equal (distance p3 p4) (+ (distance p3 ip) (distance ip p4)) 1e-6)
      )
    )

    (setq lil (mapcar (function list) pl (append (cdr pl) (list (car pl)))))
    (while (not done)
      (setq ilil
        (vl-some
          (function (lambda (a)
            (vl-some
              (function (lambda (b / ip)
                (if (vl-catch-all-error-p (setq iip (vl-catch-all-apply (function _inters) (list (car a) (cadr a) (car b) (cadr b)))))
                  (setq iip (inters (car a) (cadr a) (car b) (cadr b)))
                  (setq iip nil)
                )
                (if
                  (and 
                    (not (equal (cadr a) (car b) 1e-6))
                    (not (equal (car a) (cadr b) 1e-6))
                    (not
                      (or
                        (and
                          (collinear-p (car a) (car b) (cadr a))
                          (collinear-p (car a) (cadr b) (cadr a))
                        )
                        (and
                          (collinear-p (car b) (car a) (cadr b))
                          (collinear-p (car b) (cadr a) (cadr b))
                        )
                      )
                    )
                    (not
                      (or
                        (and
                          (collinear-p (car a) (car b) (cadr a))
                          (collinear-p (car b) (cadr a) (cadr b))
                        )
                        (and
                          (collinear-p (car b) (car a) (cadr b))
                          (collinear-p (car a) (cadr b) (cadr a))
                        )
                      )
                    )
                  )
                  (cond
                    ( (collinear-p (car a) (car b) (cadr a))
                      (setq ip (car b))
                    )
                    ( (collinear-p (car a) (cadr b) (cadr a))
                      (setq ip (cadr b))
                    )
                    ( (collinear-p (car b) (car a) (cadr b))
                      (setq ip (car a))
                    )
                    ( (collinear-p (car b) (cadr a) (cadr b))
                      (setq ip (cadr a))
                    )
                  )
                  (setq iip nil)
                )
                (cond
                  ( iip
                    (list a b iip)
                  )
                  ( ip
                    (list a b ip)
                  )
                )
              ))
              (vl-remove a lil)
            )
          ))
          lil
        )
      )
      (cond
        ( (and ilil (equal iip (caddr ilil) 1e-6))
          (setq lil (processlil ilil lil))
        )
        ( (and ilil (equal (caar ilil) (caddr ilil) 1e-6))
          (cond
            ( (and (not (equal (caar ilil) (caadr ilil) 1e-6)) (not (equal (caar ilil) (cadadr ilil) 1e-6)))
              (setq lil (processlil ilil lil))
            )
            ( (equal (caar ilil) (caadr ilil) 1e-6)
              (setq lil (processlil ilil lil))
            )
            ( (equal (caar ilil) (cadadr ilil) 1e-6)
              (setq ilil (subst (assoc (cadadr ilil) lil) (cadr ilil) ilil))
              (setq lil (processlil ilil lil))
            )
          )
        )
        ( (and ilil (equal (cadar ilil) (caddr ilil) 1e-6))
          (cond
            ( (and (not (equal (cadar ilil) (caadr ilil) 1e-6)) (not (equal (cadar ilil) (cadadr ilil) 1e-6)))
              (setq ilil (subst (assoc (cadar ilil) lil) (car ilil) ilil))
              (setq lil (processlil ilil lil))
            )
            ( (equal (cadar ilil) (caadr ilil) 1e-6)
              (setq ilil (subst (assoc (cadar ilil) lil) (car ilil) ilil))
              (setq lil (processlil ilil lil))
            )
            ( (equal (cadar ilil) (cadadr ilil) 1e-6)
              (setq ilil (subst (assoc (cadar ilil) lil) (car ilil) ilil))
              (setq ilil (subst (assoc (cadadr ilil) lil) (cadr ilil) ilil))
              (setq lil (processlil ilil lil))
            )
          )
        )
        ( (and ilil (equal (caadr ilil) (caddr ilil) 1e-6))
          (cond
            ( (and (not (equal (caadr ilil) (caar ilil) 1e-6)) (not (equal (caadr ilil) (cadar ilil) 1e-6)))
              (setq lil (processlil ilil lil))
            )
            ( (equal (caadr ilil) (caar ilil) 1e-6)
              (setq lil (processlil ilil lil))
            )
            ( (equal (caadr ilil) (cadar ilil) 1e-6)
              (setq ilil (subst (assoc (caadr ilil) lil) (car ilil) ilil))
              (setq lil (processlil ilil lil))
            )
          )
        )
        ( (and ilil (equal (cadadr ilil) (caddr ilil) 1e-6))
          (cond
            ( (and (not (equal (cadadr ilil) (caar ilil) 1e-6)) (not (equal (cadadr ilil) (cadar ilil) 1e-6)))
              (setq ilil (subst (assoc (cadadr ilil) lil) (cadr ilil) ilil))
              (setq lil (processlil ilil lil))
            )
            ( (equal (cadadr ilil) (caar ilil) 1e-6)
              (setq ilil (subst (assoc (cadadr ilil) lil) (cadr ilil) ilil))
              (setq lil (processlil ilil lil))
            )
            ( (equal (cadadr ilil) (cadar ilil) 1e-6)
              (setq ilil (subst (assoc (cadadr ilil) lil) (cadr ilil) ilil))
              (setq ilil (subst (assoc (cadar ilil) lil) (car ilil) ilil))
              (setq lil (processlil ilil lil))
            )
          )
        )
        ( t (setq done t) )
      )
    )
    (setq r (mapcar (function car) lil))
    (setq lil nil)
    r
  )

  (defun chkinters-p (pl / r lil)
    (setq lil (mapcar (function list) pl (append (cdr pl) (list (car pl)))))
    (setq r
      (vl-some
        (function (lambda (x)
          (vl-some
            (function (lambda (y)
              (and
                (not (equal (car x) (car y) 1e-6))
                (not (equal (car x) (cadr y) 1e-6))
                (not (equal (cadr x) (car y) 1e-6))
                (not (equal (cadr x) (cadr y) 1e-6))
                (or
                  (inters (car x) (cadr x) (car y) (cadr y))
                  (collinear-p (car x) (car y) (cadr x))
                  (collinear-p (car x) (cadr y) (cadr x))
                  (collinear-p (car y) (car x) (cadr y))
                  (collinear-p (car y) (cadr x) (cadr y))
                )
              )
            ))
            (vl-remove x lil)
          )
        ))
        lil
      )
    )
    r
  )

  (defun collinear-p (p1 p p2)
    (equal (distance p1 p2) (+ (distance p1 p) (distance p p2)) 1e-6)
  )

  ;; Convex Hull  -  Lee Mac
  ;; Implements the Graham Scan Algorithm to return the Convex Hull of a list of points.
  ;; Mod by M.R.  -  uses (car-sort) and (_vl-sort) subs...

  (defun MR:ConvexHull-ptsonHull (lst / ch p0 lstl)
    (cond
      ( (< (length lst) 4) (_vl-sort lst (function (lambda (a b) (if (= (cadr a) (cadr b)) (< (car a) (car b)) (< (cadr a) (cadr b)))))))
      ( (setq p0 (car lst))
        (foreach p1 (cdr lst)
          (if (or (< (cadr p1) (cadr p0)) (and (= (cadr p1) (cadr p0)) (< (car p1) (car p0))))
            (setq p0 p1)
          )
        )
        (setq lst (vl-remove p0 lst))
        (setq lst (append (list p0) lst))
        (setq lst
          (_vl-sort lst
            (function (lambda (a b / c d)
              (if
                (or
                  (equal (setq c (angle p0 a)) (setq d (angle p0 b)) 1e-8)
                  (and
                    (or
                      (equal c 0.0 1e-8)
                      (equal c (* 2 pi) 1e-8)
                    )
                    (or
                      (equal d 0.0 1e-8)
                      (equal d (* 2 pi) 1e-8)
                    )
                  )
                )
                (< (distance (list (car p0) (cadr p0)) a) (distance (list (car p0) (cadr p0)) b))
                (< c d)
              )
            ))
          )
        )
        (setq lstl (vl-remove-if-not (function (lambda (x) (equal (angle p0 (last lst)) (angle p0 x) 1e-8))) lst))
        (setq lst (vl-remove-if (function (lambda (x) (equal (angle p0 (last lst)) (angle p0 x) 1e-8))) lst))
        (setq lstl (_vl-sort lstl (function (lambda (a b) (> (distance (list (car p0) (cadr p0)) a) (distance (list (car p0) (cadr p0)) b))))))
        (setq lst (append lst lstl))
        (setq ch (list (cadr lst) (car lst)))
        (foreach pt (cddr lst)
          (if (equal pt (last lst))
            (setq ch (cons pt ch))
            (if
              (or
                (equal (angle (car ch) pt) (car-sort (mapcar (function (lambda (x) (angle (car ch) x))) (member pt lst)) (function <)) 1e-6)
                (equal (distance pt (cadr ch)) (+ (distance pt (car ch)) (distance (car ch) (cadr ch))) 1e-6)
              )
              (setq ch (cons pt ch))
            )
          )
        )
        (reverse ch)
      )
    )
  )

  (defun mindist-eea-MR (lst / f d q)

    (defun f (p lst / di)
      (while lst
        (if (equal p (car lst) (+ d 1e-8))
          (cond
            ((= (setq di (distance p (car lst))) d) (setq q (list p (car lst))))
            ((< di d)
                (setq d di
                      q (list p (car lst))
                )
            )
          )
        )
        (setq lst (cdr lst))
      )
    )

    (setq d (distance (car lst) (cadr lst)))
    (foreach a lst
      (f a (cdr lst))
      (setq lst (cdr lst))
    )
    q
  )

  (defun greedy (pl / c p1 p2 lst pp1 pp2)
    (gc)
    (if (vl-every (function null) (mapcar (function caddr) pl))
      (setq pl (mapcar (function (lambda (p) (list (car p) (cadr p) 0.0))) pl))
    )
    (setq lst (mindist-eea-MR pl))
    (setq p1 (car lst) p2 (cadr lst))
    (setq pl (vl-remove-if (function (lambda (x) (vl-some (function (lambda (y) (equal x y 1e-6))) lst))) pl))
    (while pl
      (setq pp1 (car-sort pl (function (lambda (q p) (< (distance p1 q) (distance p1 p))))))
      (setq pp2 (car-sort pl (function (lambda (q p) (< (distance p2 q) (distance p2 p))))))
      (if
        (or
          (< (distance p1 pp1) (distance p2 pp2))
          (equal (distance p1 pp1) (distance p2 pp2) 1e-6)
        )
        (progn
          (if (< (distance (car lst) pp1) (distance (last lst) pp1))
            (setq lst (cons pp1 lst))
            (setq lst (append lst (list pp1)))
          )
          (setq pl (vl-remove pp1 pl))
        )
        (progn
          (if (< (distance (car lst) pp2) (distance (last lst) pp2))
            (setq lst (cons pp2 lst))
            (setq lst (append lst (list pp2)))
          )
          (setq pl (vl-remove pp2 pl))
        )
      )
      (setq p1 (car lst) p2 (last lst))
    )
    lst
  )

  (defun grid (plst / lst a b bb d1 d2 a1 a2 e ll p pl an f)
    (gc)
    ;;;(setq plst (_vl-sort plst (function (lambda ( a b ) (< (angle a b) (angle b a)))))) ;;; already sorted in main section ;;;
    (setq lst plst)
    (exe (list "_.UCS" "_3P" "_non" (car lst) "_non" (cadr lst) "_non" (polar (car lst) (+ (angle (car lst) (cadr lst)) (* 0.5 pi)) 1.0)))
    (setq lst (mapcar (function (lambda (p) (trans p 0 1))) lst))
    (setq ll (last lst))
    (setq an 0.0)
    (setq p (car lst)
          pl (list p)
          lst (cdr lst)
    )
    (while lst
      (setq lst (_vl-sort lst (function (lambda (a b) (< (distance p a) (distance p b))))))
      (setq a1 (car lst) a2 (cadr lst))
      (setq d1 (distance p a1) d2 (if a2 (distance p a2)))
      (if
        (and
          d2
          (equal d1 d2 1e-6)
        )
        (if
          (and
            an
            (or
              (equal (angle p a1) an 1e-6)
              (equal (angle p a1) (rem (+ pi an) (+ pi pi)) 1e-6)
              (if
                (or
                  (equal an 0.0 1e-6)
                  (equal an (* 2 pi) 1e-6)
                )
                (equal (angle p a1) (* 2 pi) 1e-6)
              )
            )
          )
          (setq a a1)
          (setq a a2)
        )
        (setq a a1)
      )
      (if
        (and
          an
          (or
            (equal (angle p a) an 1e-6)
            (equal (angle p a) (rem (+ pi an) (+ pi pi)) 1e-6)
            (if
              (or
                (equal an 0.0 1e-6)
                (equal an (* 2 pi) 1e-6)
              )
              (equal (angle p a) (* 2 pi) 1e-6)
            )
          )
        )
        (setq bb a)
        (setq b a)
      )
      (if bb
        (setq b bb)
      )
      (cond
        ( (equal a1 ll 1e-6)
          (setq a a1 b a an (* 0.5 pi) f t)
        )
        ( (equal a2 ll 1e-6)
          (setq a a2 b a an (* 0.5 pi) f t)
        )
      )
      (setq pl (cons b pl)
            lst (vl-remove b lst)
            p b
            b nil
            bb nil
      )
      (if f
        (cond
          ( (= an 0.0)
            (setq an (* 0.5 pi))
          )
          (t
            (setq an 0.0)
          )
        )
        (cond
          ( (and (= an 0.0) (equal (car p) (car ll) 1e-6))
            (setq an (* 0.5 pi))
          )
          ( (and (= an (* 0.5 pi)) (equal (cadr p) (cadr ll) 1e-6))
            (setq an 0.0)
          )
          ( (and (= an (* 0.5 pi)) (equal (car p) (car ll) 1e-6))
            (setq an 0.0)
          )
          ( (and (= an 0.0) (equal (cadr p) (cadr ll) 1e-6))
            (setq an (* 0.5 pi))
          )
        )
      )
    )
    (setq pl (reverse pl))
    (setq e nil
          lst pl
          ll lst
    )
    (while (and (not e) ll)
      (setq e t
            ll lst
      )
      (while (and e ll)
        (setq ll
          (if (listp (caar ll))
            ll
            (mapcar (function list)
              (cons (last ll) ll)
              ll
            )
          )
          a (car ll)
          pl (vl-remove-if
               (function (lambda (b)
                 (or
                   (member (car a) b)
                   (member (cadr a) b)
                 )
               ))
               (cdr ll)
             )
          ll (cdr ll)
        )
        (while
          (and
            pl
            (setq b (car pl))
            (not (inters (car a) (cadr a) (car b) (cadr b)))
          )
          (setq pl (cdr pl))
        )
        (if pl
           ;;; [(car a) (cadr a) ... ->end] + ((car b) (cadr b)) - in middle of concatenated l + [start ... ->] ... (car a) - don't exist - it was (cdr-ed)
          (setq lst (append (member (car a) lst) (reverse (cdr (member (car a) (reverse lst)))))
                lst (append (list (car a)) (member (car b) (reverse (cdr lst))) (member (cadr b) lst))  ;;; [(car a)] + [(car b) + end<- ... (cadr a)] + [(cadr b) + start ... ->]
                e nil
          )
        )
      )
    )
    (setq lst
      (mapcar
        (function (lambda (p)
          (trans p 1 0)
        ))
        lst
      )
    )
    (exe (list "_.UCS" "_P"))
    lst
  )

  (defun generic (plst / lst ch inpts lil d p lilp lip)
    (gc)
    (setq lst plst)
    (setq ch (MR:ConvexHull-ptsonHull lst))
    (setq inpts
      (vl-remove-if
        (function (lambda (x)
          (vl-position x ch)
        ))
        lst
      )
    )
    (while inpts
      (setq lil (mapcar (function list) ch (append (cdr ch) (list (car ch)))))
      (foreach li lil
        (setq d (distance (car li) (cadr li)))
        (setq p (car-sort inpts (function (lambda (a b) (< (- (+ (distance (car li) a) (distance a (cadr li))) d) (- (+ (distance (car li) b) (distance b (cadr li))) d))))))
        (setq lilp (cons (list li p) lilp))
      )
      (setq lip (car-sort lilp (function (lambda (a b) (< (- (+ (distance (caar a) (cadr a)) (distance (cadr a) (cadar a))) (distance (caar a) (cadar a))) (- (+ (distance (caar b) (cadr b)) (distance (cadr b) (cadar b))) (distance (caar b) (cadar b))))))))
      (setq lil (subst (list (caar lip) (cadr lip) (cadar lip)) (car lip) lil))
      (setq ch (unique (apply (function append) lil)))
      (setq inpts (vl-remove (cadr lip) inpts))
      (setq lilp nil)
    )
    ch
  )

  (defun unique (lst / a ll)
    (while (setq a (car lst))
      (if (vl-some (function (lambda (x) (equal x a 1e-6))) (cdr lst))
        (setq ll (cons a ll) lst (vl-remove-if (function (lambda (x) (equal x a 1e-6))) (cdr lst)))
        (setq ll (cons a ll) lst (cdr lst))
      )
    )
    (reverse ll)
  )

  (defun fff (plst / lst ll dd d bb xx)
    (gc)
    (setq lst plst)
    (setq dd 1e+308 d (get-closedpolygon-length lst))
    (while (> dd d)
      (setq dd d)
      (if (chkinters-p lst)
        (setq lst (chkinters lst))
        lst
      )
      (mapcar
        (function (lambda (a b c)
          (if
            (vl-some
              (function (lambda (x)
                (if
                  (and
                    (not (equal a x 1e-6))
                    (not (equal b x 1e-6))
                    (not (equal c x 1e-6))
                    (<
                      (+ (distance a x) (distance x c))
                      (+ (distance
                           (cond
                             ( (equal x (car lst) 1e-6)
                               (last lst)
                             )
                             ( t (nth (1- (vl-position x lst)) lst) )
                           )
                           x
                         )
                         (distance
                           x
                           (cond
                             ( (equal x (last lst) 1e-6)
                               (car lst)
                             )
                             ( t (nth (1+ (vl-position x lst)) lst) )
                           )
                         )
                      )
                    )
                  )
                  (progn
                    (setq bb b)
                    (setq xx x)
                  )
                )
              ))
              (append lst lst)
            )
            (setq ll
              (mapcar
                (function (lambda (p)
                  (cond
                    ( (equal p xx 1e-6)
                      bb
                    )
                    ( (equal p bb 1e-6)
                      xx
                    )
                    ( t p )
                  )
                ))
                lst
              )
            )
          )
        ))
        lst
        (append (cdr lst) (list (car lst)))
        (append (cddr lst) (list (car lst) (cadr lst)))
      )
      (if (and ll (< (get-closedpolygon-length ll) (get-closedpolygon-length lst)))
        (setq d (get-closedpolygon-length ll) lst ll)
        (setq d (get-closedpolygon-length lst))
      )
    )
    lst
  )

  (defun makelw (lst)
    (entmake
      (append
        (list
          (cons 0 "LWPOLYLINE")
          (cons 100 "AcDbEntity")
          (cons 100 "AcDbPolyline")
          (cons 90 (length lst))
          (cons 70 (1+ (* 128 (getvar (quote plinegen)))))
          (cons 38 0.0)
        )
        (mapcar (function (lambda (x) (cons 10 x))) lst)
        (list (list 210 0.0 0.0 1.0))
      )
    )
  )


  (setq wcs (tttt t))
  (initget "Yes No")
  (setq ch
    (cond
      ( (getkword "\nIs your sample GRID-RADIAL likewise sample, or more like RND - randomize [Yes / No] <No> : ") )
      ( "No" )
    )
  )
  (initget 6)
  (setq n
    (cond
      ( (getint "\nSpecify seconds to calculate per arx/brx subs <90> : ") )
      ( 90 )
    )
  )
  (prompt "\nSelect 2D points, inserts or circles...")
  (if (setq ss (ssget (list (cons 0 "POINT,INSERT,CIRCLE"))))
    (progn
      (setq ti (car (_vl-times)))
      (repeat (setq i (sslength ss))
        (setq pl (cons (mapcar (function +) (list 0.0 0.0) (trans (cdr (assoc 10 (entget (ssname ss (setq i (1- i)))))) 0 1)) pl))
      )
      (if (= ch "Yes")
        (progn
          (setq pl (_vl-sort pl (function (lambda (a b) (< (angle a b) (angle b a))))))

          (setq pl1 (fff (greedy pl)))
          (if (chkinters-p pl1)
            (setq pl1 (chkinters pl1))
          )
          (setq pl2 (fff (grid pl)))
          (if (chkinters-p pl2)
            (setq pl2 (chkinters pl2))
          )
          (setq pl3 (fff (radial pl)))
          (if (chkinters-p pl3)
            (setq pl3 (chkinters pl3))
          )
          (setq pl4 (fff (generic pl)))
          (if (chkinters-p pl4)
            (setq pl4 (chkinters pl4))
          )
          (setq pl5 (vlce_cheapestpathlsm 3 n -1 pl))
          (if (chkinters-p pl5)
            (setq pl5 (chkinters pl5))
          )
        )
        (progn
          (setq pl6 (vlce_cheapestpathlsm 3 n -1 pl))
          (if (chkinters-p pl6)
            (setq pl6 (chkinters pl6))
          )
        )
      )
      (setq pl (car-sort (vl-remove nil (list pl6 pl5 pl4 pl3 pl2 pl1)) (function (lambda (a b) (< (get-closedpolygon-length a) (get-closedpolygon-length b))))))
      (makelw pl)
      (prompt "\nDistance - path length : ") (princ (ftoa (get-closedpolygon-length pl)))
      (prompt "\nElapsed time : ") (princ (ftoa (- (car (_vl-times)) ti))) (prompt " milliseconds...")
      (prompt "\nFor UNDO - type \"UNDO\" - \"Back\" option...")
    )
  )
  (*error* nil)
)